# This pipeline creates a new issue in the Build stage with a task
# The Test stage is set to execute manually. It will verify and pass if all tasks in the created issue have been marked complete.
# The Approve stage can only be accessed after the Test stage has passed
# The Deploy stage is only to the 'master' branch

stages:
  - 📦 Build
  - 🔍 Test
  - ✅ Approve
  - 🚀 Deploy

Create Issue:
  stage: 📦 Build
  tags:
    - k8-runner
  variables:
    URL: '$CI_API_V4_URL/projects/$CI_PROJECT_ID/issues?title=Pipeline%20$CI_PIPELINE_ID%20Task&assignee_ids=$GITLAB_USER_ID&description=*%20[%20]%20%20complete%20manual%20tests'
    URL2: '$CI_API_V4_URL/projects/$CI_PROJECT_ID/variables/issue_id'
  script:
    - |
      issue=$(curl --location --request POST "$URL" --header "PRIVATE-TOKEN: "$private_token"")
      iid=$(echo $issue | sed -nE 's/.*"iid":(.*),"project_id.*/\1/p')
    - |
      curl --request PUT --header "PRIVATE-TOKEN: "$private_token"" "$URL2" --form "key=issue_id" --form "value="$iid""

Check Manual Tasks:
  stage: 🔍 Test
  tags:
    - k8-runner
  variables:
    URL: '$CI_API_V4_URL/projects/$CI_PROJECT_ID/issues/$issue_id'
    URL2: '$CI_API_V4_URL/projects/$CI_PROJECT_ID/issues/$issue_id?state_event=close'
  script:
    - echo "Running this stage confirms that manual tests have been executed"
    - echo $URL
    - echo $URL2
    - echo $issue_id
    - |
      issue=$(curl --location --request GET "$URL" --header "PRIVATE-TOKEN: "$private_token"")
      task_count=$(echo $issue | sed -nE 's/.*"count":(.*),"completed.*/\1/p')
      task_complete_count=$(echo $issue | sed -nE 's/.*"completed_count":(.*)},"weight.*/\1/p')
    - echo $task_count
    - echo $task_complete_count
    - |
        if [ $task_count == $task_complete_count ]; then
          curl --request PUT --header "PRIVATE-TOKEN: $private_token" "$URL2"
          echo "Manual test task was marked complete"
          exit 0
        else
          echo "Manual test task has not been marked complete"
          exit 1
        fi
  environment:
    name: testing
  when: manual
  allow_failure: false

Ready for Approval:
  stage: ✅ Approve
  tags:
    - k8-runner
  script:
    - echo "Deploy to Production approved"
  environment: 
    name: production
  when: manual
  allow_failure: false
  only:
    - master

Deploy:
  stage: 🚀 Deploy
  tags:
    - k8-runner
  script:
    - echo "This job deploys something. It will only run when all jobs in the"
    - echo "test stage complete."
